//
//  UMAsset.h
//  ulib
//
//  Created by Andreas Fink on 31.01.14.
//  Copyright (c) Andreas Fink (andreas@fink.org), Basel, Switzerland. All rights reserved
//


#define UMAssert(condition, desc, ...)						\
    do 										\
    {										\
        if (!(condition)) 							\
        {									\
            [[NSAssertionHandler currentHandler] handleFailureInMethod:_cmd 	\
            object:self file:[NSString stringWithUTF8String:__FILE__] 		\
            lineNumber:__LINE__ description:(desc), ##__VA_ARGS__]; 		\
        }									\
    } while(0)
