
#import <Foundation/Foundation.h>

@interface NSObject (UMProxyForJson)
- (id)proxyForJson;
@end

@class UMJsonStreamWriter;

@protocol UMJsonStreamWriterDelegate
- (void)writer:(UMJsonStreamWriter*)writer appendBytes:(const void *)bytes length:(NSUInteger)length;
@end

@class UMJsonStreamWriterState;
@interface UMJsonStreamWriter : NSObject
{
    NSMutableDictionary *cache;
    UMJsonStreamWriterState *state;
    NSMutableArray *stateStack;
    id<UMJsonStreamWriterDelegate> __unsafe_unretained delegate;
    NSUInteger maxDepth;
    BOOL humanReadable;
    BOOL sortKeys;
    SEL sortKeysSelector;
    NSString *error;

}

@property (nonatomic, strong) UMJsonStreamWriterState *state;
@property (nonatomic, readonly, strong) NSMutableArray *stateStack;
@property (unsafe_unretained) id<UMJsonStreamWriterDelegate> delegate;
@property NSUInteger maxDepth;
@property BOOL humanReadable;
@property BOOL sortKeys;
@property (readwrite,assign) SEL sortKeysSelector;
@property (readwrite,strong) NSString *error;

- (BOOL)writeObject:(NSDictionary*)dict;
- (BOOL)writeArray:(NSArray *)array;
- (BOOL)writeObjectOpen;
- (BOOL)writeObjectClose;
- (BOOL)writeArrayOpen;
- (BOOL)writeArrayClose;
- (BOOL)writeNull;
- (BOOL)writeBool:(BOOL)x;
- (BOOL)writeNumber:(NSNumber*)n;
- (BOOL)writeString:(NSString*)s;
@end

@interface UMJsonStreamWriter (Private)
- (BOOL)writeValue:(id)v;
- (void)appendBytes:(const void *)bytes length:(NSUInteger)length;
@end

