//
//  UMLogDestination.h
//  ulib.framework
//
//  Created by Andreas Fink on 15.12.08.
//  Copyright (c) Andreas Fink (andreas@fink.org), Basel, Switzerland. All rights reserved
//

#import "UMLogEntry.h"

@interface UMLogDestination : NSObject
{
	UMLogLevel		level;
	NSLock			*_lock;
	NSMutableArray	*debugSections;
    NSMutableArray  *onlyLogSubsections;
}

@property (readwrite,assign) UMLogLevel		level;
@property (readwrite,strong) NSMutableArray	*debugSections;


- (void) logAnEntry:(UMLogEntry *)logEntry;
- (void) unlockedLogAnEntry:(UMLogEntry *)logEntry;
- (void)logNow:(UMLogEntry *)message;
- (UMLogDestination *) init;
- (NSString *)description;
- (void)lock;
- (void)unlock;
- (NSString *)oneLineDescription;

@end
