//
//  UMLogEntry.h
//  ulib.framework
//
//  Created by Andreas Fink on 15.12.08.
//  Copyright (c) Andreas Fink (andreas@fink.org), Basel, Switzerland. All rights reserved
//

#import <Foundation/Foundation.h>

#import "UMLogLevel.h"

@interface UMLogEntry : NSObject
{
	NSDate		*timeStamp;
	UMLogLevel	level;
	NSString	*section;
	NSString	*subsection;
	NSString	*name;
	NSString	*message;
	int			errorCode;
}

@property	(readwrite,strong)	NSDate		*timeStamp;
@property	(readwrite,assign)	UMLogLevel	level;
@property	(readwrite,strong)	NSString	*section;
@property	(readwrite,strong)	NSString	*subsection;
@property	(readwrite,strong)	NSString	*name;
@property	(readwrite,strong)	NSString	*message;
@property	(readwrite,assign)	int			errorCode;

- (UMLogEntry *)init;
+ (NSString *)levelName:(UMLogLevel)l;
- (NSString *)description;

@end
