//
//  UMObject.h
//  ulib
//
//  Created by Andreas Fink on 08.11.10.
//  Copyright (c) Andreas Fink (andreas@fink.org), Basel, Switzerland. All rights reserved
//

#import <Foundation/Foundation.h>

@class UMHistoryLog, UMConfig, UMLogFeed, UMLogHandler;

@interface UMObject : NSObject 
{
    UMHistoryLog *_history;
    UMLogFeed *logFeed;
}

@property (readwrite,strong) UMLogFeed *logFeed;
//@property (readonly,retain) NSString *name;

- (UMObject *) initWithHistory;

- (void) addObjectHistory:(const char *)message
                     file:(const char *)file
                     line:(long)line
                 function:(const char *)func;

- (void) addLogFromConfigGroup:(NSDictionary *)grp
                     toHandler:(UMLogHandler *)handler
                        logdir:(NSString *)logdir;

- (void) addLogFromConfigGroup:(NSDictionary *)grp
                     toHandler:(UMLogHandler *)handler;

- (void) addLogFromConfigGroup:(NSDictionary *)grp
                     toHandler:(UMLogHandler *)handler
                   sectionName:(NSString *)sec;

- (void) addLogFromConfigGroup:(NSDictionary *)grp
                     toHandler:(UMLogHandler *)handler
                   sectionName:(NSString *)sec
                subSectionName:(NSString *)ss;

- (void) addLogFromConfigGroup:(NSDictionary *)grp
                     toHandler:(UMLogHandler *)handler
                   sectionName:(NSString *)sec
                subSectionName:(NSString *)ss
                  configOption:(NSString *)configOption;

- (void) addLogFromConfigGroup:(NSDictionary *)grp
                     toHandler:(UMLogHandler *)handler
                   sectionName:(NSString *)sec
                subSectionName:(NSString *)ss
                  configOption:(NSString *)configOption
                        logdir:(NSString *)logdir;

- (id) init;
- (void) enableHistory;
- (NSString *) descriptionWithPrefix:(NSString *)prefix;

- (void)runSelectorInBackground:(SEL)aSelector
                     withObject:(id)anArgument;
- (void)runSelectorInBackground:(SEL)aSelector;
@end

#define	UMOBJECT_HISTORY(obj,message)                   [(obj) addObjectHistory:message file:__FILE__ line:__LINE__ function:__func__];
#define	UMOBJECT_HISTORY_FLF(obj,message,fil,lin,func)	[(obj) addObjectHistory:message file:(fil) line:(lin) function:(func)];
#define	UMOBJECT_ALLOC(obj,message)                     [(obj) addObjectHistory:"alloc" file:__FILE__ line:__LINE__ function:__func__];
#define	UMOBJECT_DEALLOC(obj,message)                   [(obj) addObjectHistory:"dealloc" file:__FILE__ line:__LINE__ function:__func__];
