//
//  UMQueue.h
//  thread safe generic Fifo queue
//  ulib.framework
//
//  Created by Andreas Fink on 14.12.11.
//  Copyright (c) Andreas Fink (andreas@fink.org), Basel, Switzerland. All rights reserved

#import "UMObject.h"
@class UMLock;

@interface UMQueue : UMObject
{
@private
    NSMutableArray  *queue;
    UMLock          *lock;
}

- (UMQueue *)init;
- (UMQueue *)initWithoutLock;
- (void)append:(id)obj;
- (id)getFirst;
- (id)getFirstWhileLocked;
- (void)lock;
- (void)unlock;
- (NSInteger)count;

@end
