//
//  UMSynchronizedArray.h
//  ulib
//
//  Created by Andreas Fink on 02/06/14.
//  Copyright (c) Andreas Fink (andreas@fink.org), Basel, Switzerland. All rights reserved
//

#import "UMObject.h"

@interface UMSynchronizedArray : UMObject
{
    NSMutableArray *array;
}

@property (readonly,strong) NSMutableArray *array;

- (UMSynchronizedArray *)init;
- (UMSynchronizedArray *)initWithArray:(NSArray *)arr;

+ (instancetype)synchronizedArray;
+ (instancetype)synchronizedArrayWithArray:(NSArray *)array;

- (NSUInteger)count;

- (void)addObject:(id)anObject;
- (void)insertObject:(id)anObject atIndex:(NSUInteger)index;
- (void)removeLastObject;
- (void)removeObjectAtIndex:(NSUInteger)index;
- (void)replaceObjectAtIndex:(NSUInteger)index withObject:(id)anObject;
- (id)objectAtIndex:(NSUInteger)index;


@end

