//
//  UMTimer.h
//  ulib
//
//  Created by Andreas Fink on 02/12/14.
//
//

#import "UMObject.h"
#import "UMMicroSec.h"

/* all timers are in microseconds since Jan. 1, 1970 */

@interface UMTimer : UMObject
{
    BOOL                isRunning;
    UMMicroSec          startTime;
    UMMicroSec          lastChecked;
    UMMicroSec          expiryTime;
    UMMicroSec          duration;
    NSString            *name;

    id                  __weak objectToCall;
    SEL                 selectorToCall;
    id                  parameter;
}

@property(readwrite,assign) BOOL                isRunning;
@property(readwrite,assign) UMMicroSec          startTime;
@property(readwrite,assign) UMMicroSec          lastChecked;
@property(readwrite,assign) UMMicroSec          expiryTime;
@property(readwrite,assign) UMMicroSec          duration;
@property(readwrite,strong) NSString            *name;

@property(readwrite,weak)   id                  objectToCall;
@property(readwrite,assign) SEL                 selectorToCall;
@property(readwrite,strong) id                  parameter;

- (UMTimer *)init;

- (BOOL)isRunning;
- (BOOL)isExpired;
- (BOOL)isExpired:(UMMicroSec)now;
- (UMMicroSec)timeLeft:(UMMicroSec)now;

- (void)start;
- (void)stop;
- (void)fire;

@end
