//
//  UniversalCodingProtocol.h
//  ulib
//
//  Created by Andreas Fink on 03.01.10.
//  Copyright (c) Andreas Fink (andreas@fink.org), Basel, Switzerland. All rights reserved
//


#ifndef UNIVERSALCODINGPROTOCOL_H
#define UNIVERSALCODINGPROTOCOL_H 1

#import <Foundation/Foundation.h>

/* TODO: find correct endianness for Linux. Currently we assume i386/x86_64 arch only */
#ifdef	LINUX

#ifndef	ntohll
#define ntohll(x)        OSSwapInt64(x) 
#endif

#else
#include <TargetConditionals.h>

#ifdef	TARGET_RT_LITTLE_ENDIAN
#ifndef	ntohll
#define ntohll(x)        OSSwapInt64(x) 
#endif
#ifndef htonll
#define htonll(x)        OSSwapInt64(x)  
#endif
#else 
#ifdef TARGET_RT_BIG_ENDIAN
#ifndef nothll
#define ntohll(x)        ((uint64_t)(x))
#endif
#ifndef htonll
#define htonll(x)        ((uint64_t)(x))
#endif
#else
#error unknown endianness
#endif
#endif
#endif


typedef	int64_t	M2Tag;
typedef	int64_t	M2Type;
typedef	ssize_t	M2Length;

@class	UniversalCoder;

@protocol UniversalCodingProtocol <NSObject>

//- (M2Type) m2type;
- (void) encodeWithUniversalCoder:(UniversalCoder *)aCoder;
- (id) initWithUniversalCoder:(UniversalCoder *)aDecoder;

@end

#endif
